# This method returns a dict whose keys are NE category, while its values are 
# list of spans. Each span contains the indexes of words mentioning the NE 
# in the parsed sentence.
def get_named_entity(ps, accepted_categories=[], NO_NE_LABEL="O"):
	found_named_entities = {}

	sentence_ids = ps.get_indexes()
	last_ne_cat = NO_NE_LABEL
	found_nes = {}
	ne_span = []
	
	for id in sentence_ids:
		actual_ne_category = ps.get_ne_category(id)

		# the actual token is INSIDE the span of a named entity
		if not actual_ne_category == NO_NE_LABEL:
			#this is the first token of a Named Entity
			if last_ne_cat == NO_NE_LABEL:
				ne_span = [];
			#add the id to the span of the Named Entity
			ne_span.append(id)
			
		# this is a token outside the Named Entity
		else:
			#this is a token that close a NE, i.e., the previous token is inside a NE
			if (not last_ne_cat == NO_NE_LABEL):
			
				if not accepted_categories or last_ne_cat in accepted_categories:
					if not last_ne_cat in found_named_entities:
						found_named_entities[last_ne_cat]=[]
					found_named_entities[last_ne_cat].append(ne_span)
			
		last_ne_cat = actual_ne_category
		
	return found_named_entities